	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions		
	EXPORT	main
		
;-------------------------------------	; non-initialized DATA segment in RAM 
	AREA	RAM, DATA, NOINIT, READWRITE, ALIGN=3
n	SPACE	4			; 32-bit variable 	

;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

loop					; periodic task starts here
	ldr	R0, =prompt1	
	bl	WriteString		; print a prompt

	movs	R1, #0			; init number	
	movs	R3, #0			; R3=0 for >= numbers and 1 otherwise
	
L1	bl	ReadChar		; R0 = digit
	cmp	R0, #13			; end of input?
	beq	L3
	cmp	R0, #'-'		; handle leading "-" sign
	bne	L2
	movs	R3, #1			; remember '-' sign
	b	L1	

L2	cmp	R0, #'0'
	blt	L1			; ignore wrong char
	cmp	R0, #'9'
	bgt	L1			; ignore wrong char
	subs	R0, #'0'		; ASCII conversion
	movs	R2, #10			; base system
	mla	R2, R1, R2, R0
	orrs 	R2, R2			; overflow?
	bmi	L1			; YES - ignore the last digit	
	mov	R1, R2			; NO  - accept the result 
	b	L1

L3	bl	NewLine			; end of input
	ldr	R0, =prompt2
	bl	WriteString
	mov	R0, R1			; copy the result
	orrs	R3, R3			; R3=0?
	beq	L4	
	neg	R0, R0			; negate the number otherwise

L4	ldr	R1, =n
	str	R0, [R1]		; optionally save user input in n variable
	bl	WriteInt		; control output
	bl	NewLine
	bl	NewLine
	
	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
prompt1	DCB	"Enter a number: ", 0	; allocate constant strings here
prompt2	DCB	"You entered ", 0

	ALIGN
	END